#!/usr/bin/python3
# -*- coding: utf-8 -*-

from enum import Enum


class StatusCodeEnum(Enum):
    ERRORCODE_SUCCESS = (0, 'success')
    ERRORCODE_FAILED = (1, 'failed')
    ERRORCODE_DEVICELISTEMPTY = (2, 'device list empty')
    ERRORCODE_GETSNFAILED = (3, 'get SN failed')
    ERRORCODE_GETHWVERSIONFAILED = (4, 'get hwversion failed')
    ERRORCODE_GETFILTERFAILED = (5, 'get filter failed')
    ERRORCODE_GETMIRRORFAILED = (6, 'get mirror failed')
    ERRORCODE_GETFLIPFAILED = (7, 'get flip failed')
    ERRORCODE_GETDISTANCERANGEFAILED = (8, 'get distance range failed')
    ERRORCODE_GETDISTANCEFAILED = (9, 'get distance failed')
    ERRORCODE_GETSUPPORTRESOLUTIONFAILED = (10, 'get support resolution failed')
    ERRORCODE_DEVICENOTEXIST = (11, 'device not exist')
    ERRORCODE_UNKOWNDEVICEID = (12, 'unknown device id')
    ERRORCODE_UNKOWNSTREAMTYPE = (13, 'unknown stream type')
    ERRORCODE_UNKOWNDEVICETYPE = (14, 'unknown device type')
    ERRORCODE_UNKOWNGRAPHTYPE = (15, 'unknown graph type')
    ERRORCODE_OBSERVEREMPTY = (16, 'observer empty')
    ERRORCODE_OBSERVERNOTFOUND = (17, 'observer not found')
    ERRORCODE_COUNTOUTRANGE = (18, 'count out range')
    ERRORCODE_UVCINITFAILED = (19, 'uvc init failed')
    ERRORCODE_UVCFINDDEVICEFAILED = (20, 'uvc find device failed')
    ERRORCODE_NOFRAME = (21, 'no frame')
    ERRORCODE_GETAPPFOLDERPATHFAILED = (22, 'get app folder path failed')
    ERRORCODE_NOSTREAMING = (23, 'no streaming')
    ERRORCODE_RECONSTRUCTIONEMPTY = (24, 'reconstruction empty')
    ERRORCODE_GETFILTERLISTFAILED = (25, 'get filter list failed')
    ERRORCODE_GETUNDISTORTSTATEFAILED = (26, 'get undistort state failed')

    @property
    def code(self):
        return self.value[0]

    @property
    def errmsg(self):
        return self.value[1]
